#include <iostream>
#include "machine.h"

namespace mixal {

void Machine::executeST(const InstructionWord& instruction, Register5* reg) {
    int address = getIndexedAddress(instruction);
    copyFromRegister5(instruction, *reg, &memory[address]);
}

void Machine::executeSTi(const InstructionWord& instruction) {
    int address = getIndexedAddress(instruction);
    int registerIndex = instruction.operation() - Instructions::ST1 + 1;
    auto& rIi = rI(registerIndex);
    ComputerWord word(rIi.negative, 0, 0, 0, rIi[1], rIi[2]);
    copyFromRegister5(instruction, word, &memory[address]);
}

void Machine::executeSTJ(const InstructionWord& instruction) {
    int address = getIndexedAddress(instruction);
    ComputerWord word(0, 0, 0, 0, rJ[1], rJ[2]);
    copyFromRegister5(instruction, word, &memory[address]);
}

void Machine::executeSTZ(const InstructionWord& instruction) {
    int address = getIndexedAddress(instruction);
    ComputerWord word(0, 0, 0, 0, 0, 0);
    copyFromRegister5(instruction, word, &memory[address]);
}

};  // namespace mixal
